##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic compression utilities                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate the generation of          ##
## compressed files and their inclusion in users' projects.               ##
############################################################################

## COMPRESSION EXAMPLE (Uncomment lines to use)
##

## First 3 calls to ADD2PACK add enemy, hero and background
## graphics (previously converted to binary data) into the 
## compressed group 'mygraphics'. After that, call to PACKZX7B
## compresses all the data and generates an array with the result
## that is placed in src/mygraphics.c & src/mygraphics.h, ready
## to be included and used by other modules.
##
$(eval $(call ADD2PACK,scr00,gfx/scr00.bin))
$(eval $(call PACKZX7B,scr00,src/maps/))
$(eval $(call ADD2PACK,scr01,gfx/scr01.bin))
$(eval $(call PACKZX7B,scr01,src/maps/))
$(eval $(call ADD2PACK,scr02,gfx/scr02.bin))
$(eval $(call PACKZX7B,scr02,src/maps/))
$(eval $(call ADD2PACK,scr03,gfx/scr03.bin))
$(eval $(call PACKZX7B,scr03,src/maps/))
$(eval $(call ADD2PACK,scr04,gfx/scr04.bin))
$(eval $(call PACKZX7B,scr04,src/maps/))
$(eval $(call ADD2PACK,scr05,gfx/scr05.bin))
$(eval $(call PACKZX7B,scr05,src/maps/))
$(eval $(call ADD2PACK,scr06,gfx/scr06.bin))
$(eval $(call PACKZX7B,scr06,src/maps/))
$(eval $(call ADD2PACK,scr07,gfx/scr07.bin))
$(eval $(call PACKZX7B,scr07,src/maps/))
$(eval $(call ADD2PACK,scr08,gfx/scr08.bin))
$(eval $(call PACKZX7B,scr08,src/maps/))
$(eval $(call ADD2PACK,scr09,gfx/scr09.bin))
$(eval $(call PACKZX7B,scr09,src/maps/))
$(eval $(call ADD2PACK,scr10,gfx/scr10.bin))
$(eval $(call PACKZX7B,scr10,src/maps/))
$(eval $(call ADD2PACK,scr11,gfx/scr11.bin))
$(eval $(call PACKZX7B,scr11,src/maps/))
$(eval $(call ADD2PACK,scr12,gfx/scr12.bin))
$(eval $(call PACKZX7B,scr12,src/maps/))
$(eval $(call ADD2PACK,scr13,gfx/scr13.bin))
$(eval $(call PACKZX7B,scr13,src/maps/))
$(eval $(call ADD2PACK,scr14,gfx/scr14.bin))
$(eval $(call PACKZX7B,scr14,src/maps/))
$(eval $(call ADD2PACK,scr15,gfx/scr15.bin))
$(eval $(call PACKZX7B,scr15,src/maps/))
$(eval $(call ADD2PACK,scr16,gfx/scr16.bin))
$(eval $(call PACKZX7B,scr16,src/maps/))
$(eval $(call ADD2PACK,scr17,gfx/scr17.bin))
$(eval $(call PACKZX7B,scr17,src/maps/))
$(eval $(call ADD2PACK,scr18,gfx/scr18.bin))
$(eval $(call PACKZX7B,scr18,src/maps/))
$(eval $(call ADD2PACK,scr19,gfx/scr19.bin))
$(eval $(call PACKZX7B,scr19,src/maps/))
$(eval $(call ADD2PACK,scr20,gfx/scr20.bin))
$(eval $(call PACKZX7B,scr20,src/maps/))
$(eval $(call ADD2PACK,scr20b,gfx/scr20b.bin))
$(eval $(call PACKZX7B,scr20b,src/maps/))
$(eval $(call ADD2PACK,scr21,gfx/scr21.bin))
$(eval $(call PACKZX7B,scr21,src/maps/))
$(eval $(call ADD2PACK,scr22,gfx/scr22.bin))
$(eval $(call PACKZX7B,scr22,src/maps/))
$(eval $(call ADD2PACK,scr23,gfx/scr23.bin))
$(eval $(call PACKZX7B,scr23,src/maps/))
$(eval $(call ADD2PACK,menu_scr,gfx/menu_scr.bin))
$(eval $(call PACKZX7B,menu_scr,src/))
#$(eval $(call ADD2PACK,intro1,gfx/intro1.bin))
#$(eval $(call PACKZX7B,intro1,src/))
#$(eval $(call ADD2PACK,intro2,gfx/intro2.bin))
#$(eval $(call PACKZX7B,intro2,src/))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macros used for compression are ADD2PACK and PACKZX7B:                 ##
##                                                                        ##
##	ADD2PACK: Adds files to packed (compressed) groups. Each call to this ##
##  		  macro will add a file to a named compressed group.          ##
##  PACKZX7B: Compresses all files in a group into a single binary and    ##
##            generates a C-array and a header to comfortably use it from ##
##            inside your code.                                           ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call ADD2PACK,<packname>,<file>))                            ##
##                                                                        ##
##		Sequentially adds <file> to compressed group <packname>. Each     ##
## call to this macro adds a new <file> after the latest one added.       ##
## packname could be any valid C identifier.                              ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname): Name of the compressed group where the file will be added ##
##  (file)    : File to be added at the end of the compressed group       ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call PACKZX7B,<packname>,<dest_path>))                       ##
##                                                                        ##
##		Compresses all files in the <packname> group using ZX7B algorithm ##
## and generates 2 files: <packname>.c and <packname>.h that contain a    ##
## C-array with the compressed data and a header file for declarations.   ##
## Generated files are moved to the folder <dest_path>.                   ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname) : Name of the compressed group to use for packing          ##
##  (dest_path): Destination path for generated output files              ##
##                                                                        ##
############################################################################
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##  * You can omit parameters by leaving them empty.                      ##
##  * Parameters (4) and (5) are optional and generally not required.     ##
############################################################################
