##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate tilemap conversion from    ##
## original files (like Tiled .tmx) into C-arrays.                        ##
############################################################################

##
## NEW MACROS
##

# Default values
#$(eval $(call TMX2DATA, SET_ASMVARPREFIX, yes       ))   { yes, no      }
#$(eval $(call TMX2DATA, SET_USEMACROS   , yes       ))   { yes, no      }
#$(eval $(call TMX2DATA, SET_OUTPUTS     , h c       ))   { bin hs h s c }
#$(eval $(call TMX2DATA, SET_BASE        , dec       ))   { dec hex bin }
#$(eval $(call TMX2DATA, SET_BITSPERITEM , 8         ))   { 1, 2, 4, 6, 8 }
#$(eval $(call TMX2DATA, SET_FOLDER      , src/      )) 
#$(eval $(call TMX2DATA, SET_EXTRAPAR    ,           ))	
# Conversion 
#$(eval $(call TMX2DATA, CONVERT, tmxfile, array )) 
$(eval $(call TMX2DATA, SET_ASMVARPREFIX, yes       ))   
$(eval $(call TMX2DATA, SET_USEMACROS   , yes       ))   
$(eval $(call TMX2DATA, SET_OUTPUTS     , bin       ))  
$(eval $(call TMX2DATA, SET_BASE        , dec       ))  
$(eval $(call TMX2DATA, SET_BITSPERITEM , 8         ))   
$(eval $(call TMX2DATA, SET_FOLDER      , gfx/      )) 
$(eval $(call TMX2DATA, SET_EXTRAPAR    ,           ))	
$(eval $(call TMX2DATA, CONVERT, maps/scr00.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr01.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr02.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr03.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr04.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr05.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr06.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr07.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr08.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr09.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr10.tmx,  ))
$(eval $(call TMX2DATA, CONVERT, maps/scr11.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr12.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr13.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr14.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr15.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr16.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr17.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr18.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr19.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr20.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr20b.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr21.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr22.tmx,  )) 
$(eval $(call TMX2DATA, CONVERT, maps/scr23.tmx,  )) 
