//Sistema personalizado para pintar caracteres de forma personalizada, puede tener hasta 255 caracteres
//reservándose el último (valor 255) para una marca especial de fin de línea.
//Se crean líneas que luego serán pintadas por myDrawString, para ello le pasaremos un array de bytes.
//
//Cada carácter es un sprite de 2Bytex8pixels, y la primera fila nunca puede ser 0xFF
//
//f_c será un puntero para indicar dónde empezar a pintar la línea, se irá actualizando automáticamente al llamar a myDrawString
//por lo que si son líneas seguidas, no es necesario reasignar para las siguientes líneas.
//
//f_teletipo es un booleano para que el texto se vaya pintando poco a poco (valor = 1), si se pulsa tecla, pasará a valor 0 y 
//se escribirá el resto del texto sin más pausa.
//
//Por ejemplo el siguiente texto se codificaría así
//año 2070.
//txt[10] = { 10, 36, 24, 45, 2, 0, 7, 0, 42, 255};

//Macros
#define MAX_CHARS_PER_LINE 40

extern unsigned char f_teletipo;
extern unsigned char *f_c; 
void myDrawString (unsigned char* f_l) ;

extern const unsigned char G_S0[16]; //00
extern const unsigned char G_S1[16]; //01
extern const unsigned char G_S2[16]; //02
extern const unsigned char G_S3[16]; //03
extern const unsigned char G_S4[16]; //04
extern const unsigned char G_S5[16]; //05
extern const unsigned char G_S6[16]; //06
extern const unsigned char G_S7[16]; //07
extern const unsigned char G_S8[16]; //08
extern const unsigned char G_S9[16]; //09
extern const unsigned char G_a[16];	//10
extern const unsigned char G_b[16];	//11
extern const unsigned char G_c[16];	//12
extern const unsigned char G_d[16];	//13
extern const unsigned char G_e[16];	//14
extern const unsigned char G_f[16];	//15
extern const unsigned char G_g[16];	//16
extern const unsigned char G_h[16];	//17
extern const unsigned char G_i[16];	//18
extern const unsigned char G_j[16];	//19
extern const unsigned char G_k[16];	//20
extern const unsigned char G_l[16];	//21
extern const unsigned char G_m[16];	//22
extern const unsigned char G_n[16];	//23
extern const unsigned char G_o[16];	//24
extern const unsigned char G_p[16];	//25
extern const unsigned char G_q[16];	//26
extern const unsigned char G_r[16];	//27
extern const unsigned char G_s[16];	//28
extern const unsigned char G_t[16];	//29
extern const unsigned char G_u[16];	//30
extern const unsigned char G_v[16];	//31
extern const unsigned char G_w[16];	//32
extern const unsigned char G_x[16];	//33
extern const unsigned char G_y[16];	//34
extern const unsigned char G_z[16];	//35
extern const unsigned char G_ny[16];	//36
extern const unsigned char G_at[16];	//37
extern const unsigned char G_et[16];	//38
extern const unsigned char G_it[16];	//39
extern const unsigned char G_ot[16];	//40
extern const unsigned char G_ut[16];	//41
extern const unsigned char G_pt[16];	//42
extern const unsigned char G_cm[16];	//43
extern const unsigned char G_str[16];//44
extern const unsigned char G_bl[16];	//45
extern const unsigned char G_piz[16];//46
extern const unsigned char G_pdr[16];//47
extern const unsigned char G_percent[16];//48
//extern const unsigned char G_ful[16];
//extern const unsigned char G_amc_n[16]; 
extern const unsigned char G_ap[16];	//49
extern const unsigned char G_exc[16];//50
//extern const unsigned char G_amc_f[16]; 
extern const unsigned char G_man2[16];//51
extern const unsigned char G_com[16]; //52
extern const unsigned char G_com2[16]; //53
extern const unsigned char G_man3[16];//54
extern const unsigned char G_com3[16]; //55
extern const unsigned char G_amp[16];	//56
//extern const unsigned char G_amc_g[16]; 
//extern const unsigned char G_amc_r[16]; 
//extern const unsigned char G_amc_o[16]; 



	


//Caracter especial para indicar final de línea y no tener que crear un array de MAX_CHARS_PER_LINE. Contiene 0xFF, por lo que ningún sprite de fuente
//puede ser FF en su primera línea
extern const unsigned char G_eol[1];//255