#include <cpctelera.h>
#include "main.h"
#include "graphics.h"
#include "render.h"
#include "consola.h"
#include "PlayerAKG.h"
extern u8* GAME1_START;
extern u8* GAME2_START;
extern u8* SFX_SOUNDEFFECTS;

void entering();

u8 abs (i16 valor){
   return (valor > 0 ? valor : -valor);
}

u8 maximo (u8 punto1, u8 punto2) {
  return (punto1 > punto2 ? punto1 : punto2);
}

void addScore(u16 valor){
	/*u32 overflow;

	overflow = score + valor;
	if (overflow > 65535)
		score = 65535;
	else
		score = overflow;*/
	score = score + valor;
}

void initXY (u8 entidad, u8 xy, u8 valor) {
	if (xy == 0) {
		entidades[entidad].x = entidades[entidad].x_anterior_A = entidades[entidad].x_anterior_B = valor;
	}
	if (xy == 1) {
		entidades[entidad].y = entidades[entidad].y_anterior_A = entidades[entidad].y_anterior_B = valor;
	}
}

void resetMov (u8 entidad){
	entidades[entidad].movimientoH = entidades[entidad].movimientoV = 0;
}

i8 posProtagonista (u8 entidad, u8 tipo) { //entidad = índice en tabla entidades; tipo = 0, eje X; 1, eje Y
	i8 valor;
	u8 posicion, referencia, margen;

	

	// tipo == 0
	posicion = entidades[0].x + 1;
	referencia = entidades[entidad].x;
	
	if (tipo == 1) {
		posicion = entidades[0].y + 8;
		referencia = entidades[entidad].y;
	}

	margen = cpct_rand() % (4 + tipo*4);

	valor = 0;
	if (posicion < referencia + margen)
		valor = -1;
	if (posicion > referencia + margen)
		valor = 1;

	return valor;
}

void clearScr(){
	cpct_memset ((u8*) 0x8000, cpct_px2byteM0 (0, 0), 0x8000);
	cpct_memcpy (&paleta[0],&paleta_original,16);
  	cpct_setPalette(paleta,16); 
}

u16 tileCell(u8 x, u8 y) {
  return ((20*((y - AREA_JUEGO_SUP) /8)) + (x/4));
}

u8 tileValue(u8 x, u8 y){
  return (mapa[tileCell(x, y)]);
}

u8 typeOfTile(u8 tileV){
 if (tileV <= MAX_TILES_SOLID)
    return 1;
  else if (tileV <= MAX_TILES_LETHAL)
    return 2;
  else
    return 0;
}


u8 sigEntidad() {
	u8 i;
	//Buscar hueco en tabla entidades
	for (i=1; i<MAX_ENTIDADES; i++) {
		if (entidades[i].id == 0)
			break;
	}

	return i;
}

void actualizaEnergia(i8 valor) {

	if ((valor*-1) > energia)
		energia = 0;

	if (energia > 0)	{
		energia = energia + valor;

		//Comprobar límites
		if (energia > MAX_ENERGIA)
			energia = MAX_ENERGIA;

		if (valor < 0) {
			entidades[0].data2=10; //ciclos de inmunidad si perdemos energía
		} 
	} else {
		finFase = 1;
		game_over = 1;
	} 

	pintarEnergia();
	
}

void punteroEnemigos(){
  u8 i;
 
  enemigos_ptr = &enemigos[0];

  i = 0;
  //while (i < hab_mezcladas[habitacion]) {
  while (i < habitacion) {
    while (enemigos_ptr->id != 255){ //mientras el id no sea 255, saltar enemigos
      enemigos_ptr++;
    }
    enemigos_ptr++; //saltar marca de fin
    i++;
  }
}

void desaparecerEntidad (u8 n){

	if (entidades[n].id != 0 ) {
		if (entidades[n].id == TIPO_CONCURSANTE_1 || entidades[n].id == TIPO_CONCURSANTE_2) {
			entidades[n].id = TIPO_NULL;
			entidades[n].propiedades =  entidades[n].propiedades & ~mask_perseguidor;
			resetMov(n);
		} else {
			entidades[n].id = 255; //Marca para borrarlos
			entidades[n].propiedades = 0; 
		}
	}
}

void crearItem(u8 llave) {
	u8 i,temp;
	u16 tile;	

	i = sigEntidad();
	if (i < MAX_ENTIDADES) {
		do {
			tile = tileItems[cpct_rand()%6];
		} while (tile == 0xFFFF || tile == tileItems[6]);
		entidades[i].id = 0;
		tileItems[6]=tile; //Se guarda el actual para que el siguiente no sea el mismo y el nº de entidad en la tabla
		tileItems[7]=i;
		tile = tile - 20; //Pintarlo arriba del tile bandeja
		initXY (i,0, 4 * (tile%20));
		initXY (i,1, (8 * (tile/20)) + AREA_JUEGO_SUP);
		resetMov (i);
		entidades[i].ancho = 4;
		entidades[i].alto = 8;
		entidades[i].propiedades = mask_pintar;

		if (llave) { 
			// Si estamos en la habitación correspondiente habrá una tarjeta
			temp = 255;
			if (habitacion == tarjetas[0])
				temp = 0;
			if (habitacion == tarjetas[1])
				temp = 1;
			if (habitacion == tarjetas[2])
				temp = 2;

			if (temp != 255) {
				entidades[i].id = TIPO_TARJETA;
				entidades[i].ancho = 3;
				entidades[i].sprite_f1 = (u8*) &G_Card_R[0];
				entidades[i].sprite_f1 = entidades[i].sprite_f1 + (48*temp);
			}
		} else if (tiempo) {
			entidades[i].data1=127; //Duración en pantalla hasta desaparecer

			temp = cpct_rand()% 100;

			if (bonus_medical>=2000) {
				temp = 100;
				bonus_medical = bonus_medical - 2000;
				entidades[i].id = TIPO_BOTIQUIN;
				entidades[i].ancho = 3;
				entidades[i].sprite_f1 = (u8*) &G_Medical[0];
			}
			if (temp < 30)  { //30% Moneda
				entidades[i].id = TIPO_MONEDA;
				entidades[i].sprite_f1 = (u8*) &G_Coin_1[0] + (moneda_bonus*64);
			} else if (temp < 90 )  { //60% Reloj
				entidades[i].id = TIPO_RELOJ;
				entidades[i].sprite_f1 = (u8*) &G_Clock_1[0] + (reloj_bonus*64);
			} else if (temp < 95 )  { //5% Inmune
				entidades[i].id = TIPO_INMUNIDAD;
				entidades[i].sprite_f1 = (u8*) &G_Inmune[0];
			} else if (temp < 100 )  { //5% Parar Enemigos
				entidades[i].id = TIPO_CONGELAR;
				entidades[i].sprite_f1 = (u8*) &G_Parar[0];
			}
		}
	}
}

void crearDisparo(u8 i) {
	u8 new;

	new = sigEntidad();
	if (new < MAX_ENTIDADES) { //Asegurarnos que hay hueco para el disparo

		entidades[new].movimientoH = posProtagonista (i, 0);
		entidades[new].movimientoV = posProtagonista (i, 1);
		entidades[new].propiedades = mask_disparo | mask_pintar;
		entidades[new].id = 11;
		entidades[new].ancho = 2;
		entidades[new].alto = 8;
		entidades[new].sprite_f1 = (u8*) &G_Shot[0];
		initXY (new,0, entidades[i].x);
		initXY (new,1, entidades[i].y+6);
		
	}
}

void generarEnemigos(u8 n){
	if (enemigos_ptr->id != 255) {
		entidades[n].id = enemigos_ptr->id;
		initXY (n,0, enemigos_ptr->x);
		initXY (n,1, enemigos_ptr->y);
		entidades[n].propiedades = mask_pintar | mask_frames;
		entidades[n].ancho = 4;
		entidades[n].alto = 16;
		resetMov (n);
		entidades[n].data1 = 1;
		entidades[n].data2 = enemigos_ptr->data;

		if (enemigos_ptr->id == TIPO_EJES || enemigos_ptr->id == TIPO_DISPARO || enemigos_ptr->id == TIPO_ALEATORIO) { 
			if (entidades[n].data2 & 0x01)
	   		entidades[n].movimientoH = 1;
	   	if (entidades[n].data2 & 0x02)
	   		entidades[n].movimientoV = 1;

			entidades[n].propiedades = entidades[n].propiedades | mask_rebotables;
				
			entidades[n].sprite_f1 = (u8*) &G_Droid_F1[0];
			if (enemigos_ptr->id == TIPO_DISPARO)
				entidades[n].sprite_f1 = (u8*) &G_Droid_F1_2[0];
		}  

		if (enemigos_ptr->id == TIPO_PERSEGUIDOR) { //Persecución
				
			entidades[n].sprite_f1 = (u8*) &G_Droid_F1_3[0];
			entidades[n].propiedades = entidades[n].propiedades | mask_perseguidor;
		} 

		if (enemigos_ptr->id == TIPO_PERS_ESTATICO) { //Persecución por cercanía (estático o patrullando)
			entidades[n].sprite_f1 = (u8*) &G_Droid_F1_3[0];
		} 

		if (enemigos_ptr->id == TIPO_PERS_PATRULLA) { //Persecución por cercanía (estático o patrullando)
			entidades[n].sprite_f1 = (u8*) &G_Droid_F1_3[0];
			entidades[n].propiedades = entidades[n].propiedades | mask_rebotables;
		} 

		if (enemigos_ptr->id == TIPO_CANNON) { //Droide Cañon
			if (entidades[n].data2 & 0x01) {
				if (entidades[n].data2 != 1)
					entidades[n].movimientoV = 1;

				entidades[n].sprite_f1 = (u8*) &G_Droid2_F1[0];
			}
	   	if (!(entidades[n].data2 & 0x01)){
	   		if (entidades[n].data2 != 0)
	   			entidades[n].movimientoH = 1;

	   		entidades[n].sprite_f1 = (u8*) &G_Droid2_F2[0];
	   	}
				
			entidades[n].data1 = RESET_DISPARO;
			entidades[n].propiedades = mask_pintar | mask_rebotables;
		}  

		if (enemigos_ptr->id == TIPO_PINCHOS) { //Pinchos
			entidades[n].ancho = 10;
		} 

		if (enemigos_ptr->id == TIPO_POSTES) { //Postes
			entidades[n].sprite_f1 = (u8*) &G_Post_F1[0];
		} 

		if (enemigos_ptr->id == TIPO_CONCURSANTE_1) {
			entidades[n].sprite_f1 = (u8*) &G_Opp_R_F1[0];
			entidades[n].propiedades = entidades[n].propiedades | mask_perseguidor;
		}

		if (enemigos_ptr->id == TIPO_CONCURSANTE_2) {
			entidades[n].sprite_f1 = (u8*) &G_Opp_R_F1_COPY[0];
		}

		if (enemigos_ptr->id == TIPO_OJOS) {
			entidades[n].sprite_f1 = (u8*) &G_Eyes[0];
			entidades[n].alto = 8;
			entidades[n].propiedades = mask_pintar;
		}

		entidades[n].sprite_f2 = entidades[n].sprite_f1 + (entidades[n].ancho*entidades[n].alto*2);
		entidades[n].sprite_f3 = entidades[n].sprite_f2 + (entidades[n].ancho*entidades[n].alto*2);
		
		// Los que sólo tienen 2 frames de animación
		if (enemigos_ptr->id == TIPO_POSTES){ 
			entidades[n].sprite_f3 = entidades[n].sprite_f1;
		}

		if (enemigos_ptr->id == TIPO_ALEATORIO){ 
			entidades[n].sprite_f2 = (u8*) &G_Droid_F2_COPY[0];
		}

		enemigos_ptr++; //Puntero a siguiente enemigo
	} 
}


void initFase(){
	u8 i;
	u16 j;

	for (i=1; i<MAX_ENTIDADES; i++) {
		entidades[i].id = 0; //Marca de inactivo
		entidades[i].propiedades = 0; 
	}

	for (i=0; i<8; i++) {
		tileItems[i] = 0xFFFF; 
	}

	pintarEscenario();

	//Obtener tiles para items
	i=0;
	for (j=0;j<20*23;j++) {
		if (mapa[j]==TILE_ITEMS) {
			tileItems[i] = j;
			i++;
		}
	}

	if (!cpct_getBit (&laberinto_hechos[0], habitacion)) { //Generar Enemigos y Temporizador si la habitación no ha sido superada aún
		punteroEnemigos();

		do {
			i = sigEntidad();
			generarEnemigos (i);
		}
		while (enemigos_ptr->id != 255);

		tiempo = 224;
		reloj_bonus = 0;
	  moneda_bonus = 0;
		crearItem(0);
	} else { //Si ya está completada la habitación pero no se cogió la tarjeta que vuelva a aparecer
		if (habitacion == tarjetas[0] || habitacion == tarjetas[1] || habitacion == tarjetas[2]) {
			crearItem(1);
		}
	}
	pintarMarcador();	

	finFase = 0;
  stop = 0;

	energia_fin = energia;
}

u8 hayColision(u8 entidad1) {
//Comprobar colisión entre elemento 0 y elemento 1. 
//Elemento 1 es el que se está calculando la nueva posición
	/*if ( entidades[0].x + 4  > entidades[entidad1].x 
		&& entidades[0].x + 1  < entidades[entidad1].x + entidades[entidad1].ancho 
		&& entidades[0].y + 30 > entidades[entidad1].y 
		&& entidades[0].y + 2  < entidades[entidad1].y + entidades[entidad1].alto) {*/
	if ( entidades[0].x + 3  > entidades[entidad1].x 
		&& entidades[0].x + 1  < entidades[entidad1].x + entidades[entidad1].ancho 
		&& entidades[0].y + 16 > entidades[entidad1].y 
		&& entidades[0].y + 0  < entidades[entidad1].y + entidades[entidad1].alto) {
		return 1; 
	} 
	return 0;
}


void colisiones(){
	u8 i, bonus,item;

	for (i = 1; i < MAX_ENTIDADES; i++) {
		if (entidades[i].id != 0 && entidades[i].propiedades & mask_pintar) {
			if ((entidades[i].id == TIPO_PINCHOS && entidades[i].data1 > 30) //Pinchos apareciendo, no quita energía
				|| ((entidades[i].id == 14) && entidades[i].data1 > 40) ) //Láser apareciendo, no quita energía
				continue;
			
			//Concursante roba items
			if (entidades[i].id == TIPO_CONCURSANTE_2 && tileCell(entidades[i].x,entidades[i].y+8) == tileItems[6] && tiempo) {
				if (entidades[tileItems[7]].id == TIPO_MONEDA)
						moneda_bonus = 0;
					if (entidades[tileItems[7]].id == TIPO_RELOJ)
						reloj_bonus = 0;
				desaparecerEntidad(tileItems[7]);
				crearItem(0);
			}

			if ( hayColision(i)) {
				item = 0;
				if (entidades[i].id == TIPO_BOTIQUIN) {
					playFX(4);
					actualizaEnergia(10);
					desaparecerEntidad(i);
					if (tiempo)
						item = 1;
				} else if (entidades[i].id == TIPO_TARJETA) {
					playFX(8);
					tarjetas[habitacion/24] = 255;
					pintarMarcador();
					desaparecerEntidad(i);
				} else if (entidades[i].id == TIPO_MONEDA) {
					playFX(2);
					bonus = 25;
					if (moneda_bonus == 1)
						bonus = 100;
					else if (moneda_bonus == 2)
						bonus = 200;

					addScore(bonus);
					bonus_medical = bonus_medical + bonus;
					moneda_bonus++;
					if (moneda_bonus == 3)
						moneda_bonus=2;

					printScore(score, 0);
					item = 1;
				} else if (entidades[i].id == TIPO_RELOJ) {
					playFX(3);
					bonus = 12;
					if (reloj_bonus == 1)
						bonus = 24;
					else if (reloj_bonus == 2)
						bonus = 48;

					if (tiempo > bonus)
						tiempo = tiempo - bonus;
					else
						tiempo = 0;


					reloj_bonus++;
					if (reloj_bonus == 3)
						reloj_bonus=2;

					pintarTiempo();
					item = 1;
				} else if (entidades[i].id == TIPO_INMUNIDAD) {
					playFX(5);
					entidades[0].data2=127;
					item = 1;
				} else if (entidades[i].id == TIPO_CONGELAR) {
					playFX(6);
					stop=80;
					item = 1;
				} else {
					//ENEMIGOS
					if (entidades[0].data2 == 0) { //Si no es inmune, quitar energía
						playFX(1);
						actualizaEnergia(-1);	
					}
				}

				if (item) { //Si se cogió item, hacerlo desaparecer y crear uno nuevo
					desaparecerEntidad(i);
					if (tiempo)
						crearItem(0);
				}
			}

		}
	}
}

void teclado(){
	resetMov (0);
  	
	cpct_scanKeyboard_f();  
  	if (cpct_isKeyPressed(Key_Q) || cpct_isKeyPressed(Joy0_Up) || cpct_isKeyPressed(Key_CursorUp) ) {
		entidades[0].movimientoV = -1;
		entidades[0].data1 = 2;
	}
	if (cpct_isKeyPressed(Key_A) || cpct_isKeyPressed(Joy0_Down) || cpct_isKeyPressed(Key_CursorDown)) {
		entidades[0].movimientoV = 1;
		entidades[0].data1 = 3;
	}
	if (cpct_isKeyPressed(Key_O) || cpct_isKeyPressed(Joy0_Left) || cpct_isKeyPressed(Key_CursorLeft)) {
		entidades[0].movimientoH = -1;
		entidades[0].data1 = 1;
	}
	if (cpct_isKeyPressed(Key_P) || cpct_isKeyPressed(Joy0_Right) || cpct_isKeyPressed(Key_CursorRight)) {
		entidades[0].movimientoH = 1;
		entidades[0].data1 = 0;
	}

	if (entidades[0].movimientoH != 0 || entidades[0].movimientoV != 0) 
		entidades[0].propiedades = entidades[0].propiedades | mask_frames;
	else
		entidades[0].propiedades = entidades[0].propiedades & ~mask_frames;


	/*if (cpct_isKeyPressed(Key_H) && cpct_isKeyPressed(Key_A) && cpct_isKeyPressed(Key_C) && cpct_isKeyPressed(Key_K) ) {   
		tiempo = 0;
	}*/

	/*if (cpct_isKeyPressed(Key_F1) ) {
		// *** 
		finFase=1;
		habitacion--;
		initFase();
	}

	if (cpct_isKeyPressed(Key_F2) ) {  
		// *** 
		finFase=1;
		habitacion++;
		initFase();
	}*/

}

void iA(){
	u8 i,new;
	u8 x,y;

	if (entidades[0].data2 != 0)
		entidades[0].data2--;

	for (i = 1; i < MAX_ENTIDADES; i++) {
		if (entidades[i].id != 0 && stop==0) { //Para entidades vivas 
			if (entidades[i].id == TIPO_EJES && entidades[i].data2 == 3) { 
			  //Los rebotables a veces se quedan atascados en el mismo patrón, añadir un elemento aleatorio
				if (cpct_rand()%128 == 0)
					entidades[i].movimientoH = entidades[i].movimientoH * -1;
				if (cpct_rand()%128 == 1)
					entidades[i].movimientoV = entidades[i].movimientoV * -1;
			}

			if (entidades[i].id == TIPO_ALEATORIO ) { //Mov Aleatorio
				entidades[i].data1--;
				if (entidades[i].data1 == 0) {
					entidades[i].movimientoV = (cpct_rand() % 3) - 1;
					entidades[i].movimientoH = (cpct_rand() % 3) - 1;
					entidades[i].data1 = entidades[i].data2;
				}
			}

			if (entidades[i].id == TIPO_PERS_ESTATICO || entidades[i].id == TIPO_PERS_PATRULLA) { //Detectar cercanía del protagonista
				x = entidades[0].x + 1;
				y = entidades[0].y + 8;

				if (abs(entidades[i].x - x) + abs(entidades[i].y - y)/4 < 30) {
					entidades[i].propiedades = entidades[i].propiedades | mask_perseguidor;
				} else {
					entidades[i].propiedades = entidades[i].propiedades & ~mask_perseguidor;
					entidades[i].data1 = 1;
					if (entidades[i].id == TIPO_PERS_PATRULLA && entidades[i].movimientoH == 0) {
						entidades[i].movimientoH = 1;
					}
				}
			}

			if (entidades[i].propiedades & mask_perseguidor) { //Persecución
				entidades[i].data1--;
				if (entidades[i].data1 == 0) {
					entidades[i].movimientoH = posProtagonista (i, 0);
					entidades[i].movimientoV = posProtagonista (i, 1);

					entidades[i].data1 = entidades[i].data2; //Velocidad de persecución
					
					//Evitar bloqueo por una pared
					/*if (entidades[i].movimientoH == 0 && entidades[i].x == entidades[i].x_anterior_A)
						entidades[i].movimientoH = -1;

					if (entidades[i].movimientoV == 0 && entidades[i].y == entidades[i].y_anterior_A)
						entidades[i].movimientoV = -1;*/

				} else {
					resetMov (i);
				}

				if (entidades[i].id == TIPO_CONCURSANTE_1) {
					if (frames % 64 > 15 + (habitacion/8)) { //Descansa, no persigue (A más profundidad, descansará menos)
						entidades[i].propiedades = entidades[i].propiedades & ~mask_frames;
						entidades[i].data1 = 2; 
					}
					else {
						entidades[i].propiedades = entidades[i].propiedades | mask_frames;
						if (entidades[i].movimientoH == -1)
							entidades[i].sprite_f1 = (u8*) &G_Opp_L_F1[0];
						if (entidades[i].movimientoH == 1)
							entidades[i].sprite_f1 = (u8*) &G_Opp_R_F1[0];
						entidades[i].sprite_f2 = entidades[i].sprite_f1 + (entidades[i].ancho*entidades[i].alto*2);
						entidades[i].sprite_f3 = entidades[i].sprite_f2 + (entidades[i].ancho*entidades[i].alto*2);
					}
				}
			}

			if (entidades[i].id == TIPO_CANNON) {
				entidades[i].data1--;
				if (entidades[i].data1 == 0) {

					new = sigEntidad();
					if (new < MAX_ENTIDADES) { 
						resetMov (new);
						entidades[new].propiedades = mask_disparo | mask_pintar;
						entidades[new].id = 8;
						entidades[new].ancho = 1;
						entidades[new].alto = 6;
						initXY (new,0, entidades[i].x);
						initXY (new,1, entidades[i].y+6);
						if (!(entidades[i].data2 & 0x01)) {
							entidades[new].id = 9;
							entidades[new].ancho = 2;
							entidades[new].alto = 1;
							entidades[new].x = entidades[i].x + 1;
							entidades[new].y = entidades[i].y + 16;
						}
						
						
						
					}
					entidades[i].data1 = RESET_DISPARO + cpct_rand() % RESET_DISPARO;
				}
			}

			if (entidades[i].id == 8) {
				if (entidades[i].ancho < 12){
					entidades[i].ancho += 1;
					entidades[i].x -= 1;
				} else {
					entidades[i].movimientoH = -2;
				}
			}

			if (entidades[i].id == 9) {
				if (entidades[i].alto < 32){
					entidades[i].alto += 4;
				} else {
					entidades[i].movimientoV = 2;
				}
			}


			if (entidades[i].id == TIPO_DISPARO) {
				entidades[i].data1--;
				if (entidades[i].data1 == 0) {
					crearDisparo(i);
					
					entidades[i].data1 = RESET_DISPARO;
				}
			}

			if (entidades[i].id == TIPO_OJOS) {
				
				entidades[i].movimientoH = 0;
				entidades[i].data1--;
				if (entidades[i].data1 == 0) {				
					if (entidades[i].x == 28 || entidades[i].x == 44) 
						entidades[i].movimientoH = 4;
					if (entidades[i].x == 32 || entidades[i].x == 48) 
						entidades[i].movimientoH = -4;

					crearDisparo(i);
					entidades[i].data1 = RESET_DISPARO + cpct_rand() % 32;
				}
			}

			if (entidades[i].id == TIPO_PINCHOS) {
				entidades[i].data1--;
				if (entidades[i].data1 == 45) {
					if (entidades[0].x < 7) 
						entidades[i].x = 4;
					else
						entidades[i].x = entidades[0].x - 3;

					if (entidades[i].x > 66) 
						entidades[i].x = 66;

					entidades[i].y = entidades[0].y + 8 + cpct_rand() % 16;

					if (entidades[i].y > 184) 
						entidades[i].y = 184;
				}
				if (entidades[i].data1 == 40) {
					entidades[i].sprite_f1 = (u8*) &G_Spikes_F1[0];
					entidades[i].alto = 3;
					entidades[i].propiedades = mask_pintar;
				} 
				if (entidades[i].data1 == 30) {
					entidades[i].sprite_f1 = (u8*) &G_Spikes_F2[0];
					entidades[i].alto = 8;
					entidades[i].y = entidades[i].y - 5;
				} 

				if (entidades[i].data1 == 0) {
					entidades[i].data1 = 50 + cpct_rand() % 40;
					entidades[i].propiedades = 0;
				}
			}

			if (entidades[i].id == TIPO_POSTES) {
				entidades[i].data1--;

				if (entidades[i].data1 == 50) {
					new = sigEntidad();
					if (new < MAX_ENTIDADES) { 
						resetMov (new);
						entidades[new].propiedades = mask_disparo | mask_pintar;
						entidades[new].id = 14;
						entidades[new].ancho = 1;
						entidades[new].alto = 60;
						initXY (new,0, entidades[i].x + 1);
						initXY (new,1, entidades[i].y + 18);
						entidades[new].data1 = 50;
					}
				}


				if (entidades[i].data1 == 0) {
					entidades[i].data1 = entidades[i].data2;
				}
			}

			if (entidades[i].id == 14) {
				entidades[i].data1--;
				if (entidades[i].data1 == 40) 
					entidades[i].ancho = 2;
				if (entidades[i].data1 == 0) 
					desaparecerEntidad(i);
			}

			if (entidades[i].id == TIPO_CONCURSANTE_2) {
				resetMov (i);
				entidades[i].data1--;
				if (entidades[i].data1 == 0) {
					entidades[i].data1 = entidades[i].data2;
					x = 4 * (tileItems[6] % 20);
					if (entidades[i].x < x) 
						entidades[i].movimientoH = 1;
					if (entidades[i].x > x) 
						entidades[i].movimientoH = -1;

					y = 8 * ((tileItems[6] / 20)) + 8;
					if (entidades[i].y < y) 
						entidades[i].movimientoV = 1;
					if (entidades[i].y > y)
						entidades[i].movimientoV = -1;
					
					entidades[i].sprite_f1 = (u8*) &G_Opp_L_F1_COPY[0];
					if (entidades[i].movimientoH ==  1)
						entidades[i].sprite_f1 = (u8*) &G_Opp_R_F1_COPY[0];

					entidades[i].sprite_f2 = entidades[i].sprite_f1 + (entidades[i].ancho*entidades[i].alto*2);
					entidades[i].sprite_f3 = entidades[i].sprite_f2 + (entidades[i].ancho*entidades[i].alto*2);
				}
			}

			if (entidades[i].id >= TIPO_MONEDA && entidades[i].id <= TIPO_BOTIQUIN) {
				entidades[i].data1--;
				if (entidades[i].data1 == 0) {
					if (entidades[i].id == TIPO_MONEDA)
						moneda_bonus = 0;
					if (entidades[i].id == TIPO_RELOJ)
						reloj_bonus = 0;

					desaparecerEntidad(i);
					crearItem(0);
				}

					
			}

		}
	}
}

u8 colisionTiles (u8 pos_x, u8 pos_y, u8 entidad) {
	// Devuelve la unión de 
	// 0b00000010 = colision lateral
	// 0b00000001 = colision vertical
	// 0b00000100 = colision letal

	//Las entidades no pueden ser de más de 16 de alto
	u8 desplazamiento,colision;
	u16 tile;
	u8 y,alto;

	colision = 0;

	desplazamiento = 0;
	y = entidades[entidad].y;
	if (entidades[entidad].alto == 16) { //Para las entidades de 16 pixeles de alto, sólo revisar parte de abajo
		desplazamiento = 8;
		y = y + 8;
	}

	tile = tileCell(entidades[entidad].x, y);

	if (entidades[entidad].movimientoH == -1) 
		tile = tileCell(pos_x, y);

	if (entidades[entidad].movimientoH == 1) 
		tile = tileCell(pos_x+entidades[entidad].ancho-1, y);

	

	while (1) {
		if (typeOfTile(mapa[tile]) == 1) {
			colision = colision | 0b00000010; //Colisión lateral
		}
		if (typeOfTile(mapa[tile]) == 2) {
			colision = colision | 0b00000100; //Colisión Letal
		}
		desplazamiento = desplazamiento + 8;
		tile = tile + 20; //20 por fila, mirar siguiente fila

		if (desplazamiento > entidades[entidad].alto || (desplazamiento == entidades[entidad].alto && entidades[entidad].y % 8 == 0))
			break;
	}

	y = pos_y;
	alto = entidades[entidad].alto;
	if (entidades[entidad].alto == 16) { //Para las entidades de 16 pixeles de alto, sólo revisar parte de abajo
		alto = alto - 8;
		y = y + 8;
	}
	
	tile = tileCell(entidades[entidad].x, y);
	
	if (entidades[entidad].movimientoV == -1) 
		tile = tileCell(entidades[entidad].x, y);

	if (entidades[entidad].movimientoV == 1) 
		tile = tileCell(entidades[entidad].x, y+alto-1);

	desplazamiento = 0;
	while (1) {
		if (typeOfTile(mapa[tile]) == 1) {
			colision = colision | 0b00000001; //Colisión vertical
		}
		if (typeOfTile(mapa[tile]) == 2) {
			colision = colision | 0b00000100; //Colisión Letal
		}
		desplazamiento = desplazamiento + 4;
		tile = tile + 1; //mirar siguiente

		if (desplazamiento > entidades[entidad].ancho || (desplazamiento == entidades[entidad].ancho && entidades[entidad].x % 4 == 0))
			break;
	}

	return colision;
}


void moverEntidades() {
	u8 i,x,y,colision;

	if (stop) 
		stop--;

	for (i = 0; i < MAX_ENTIDADES; i++) {
		if (entidades[i].id != 0 && entidades[i].id < TIPO_MONEDA
			&& (i==0 || entidades[i].movimientoH || entidades[i].movimientoV)) { 
			//Para entidades vivas y se hayan movido (o protagonista se quede en tiles letales)
			colision = 0;

			if (entidades[i].id == TIPO_DISPARO && ciclo%2 == 0) //los de tipo disparo se mueven a mitad de velocidad
				continue;

			
			x = entidades[i].x;
			y = entidades[i].y;

			x = x + (  entidades[i].movimientoH);
			y = y + (4*entidades[i].movimientoV); 

			//Si está activo el ítem de parar los enemigos, no se mueven
			if (stop && i!=0) {
				x = entidades[i].x;
				y = entidades[i].y;
			}
			

			//*((u8*) 0xFFFE) = y;
			//*((u8*) 0xFFFF) = x;
			
			colision = colisionTiles (x, y, i);

			//Colisión con tiles letales
			if (i == 0 && (colision & 0b00000100) && (entidades[0].data2 == 0)) {
				playFX(7);
				actualizaEnergia(-1);
			}

			//ÁREA DE JUEGO. Si se sale del mismo, avisar de colisión
		/*if ( x > (AREA_JUEGO_DCHA  - entidades[i].ancho))
        colision = colision | 0b00000010; //Colisión derecha
    	//if ( x < AREA_JUEGO_IZQ )
			//		colision = colision | 0b00001010; //Colisión izquierda

		if ( y > (AREA_JUEGO_INF - entidades[i].alto))
				colision = colision | 0b00000001; //Colisión abajo
		if ( y < AREA_JUEGO_SUP )
				colision = colision | 0b00000101; //Colisión arriba*/

			//if (i==0)		*((u8*) 0xFFFF) = colision;

      //Tratar diferente la colisión horizontal y vertical para el efecto deslizamiento
   		if ((colision & 0x02) == 0) {
				entidades[i].x = x;
   		} else {
   			if (entidades[i].propiedades & mask_rebotables) 
					entidades[i].movimientoH = entidades[i].movimientoH * -1;
   		}
			if ((colision & 0x01) == 0) {
				entidades[i].y = y;
			} else {
   			if (entidades[i].propiedades & mask_rebotables) 
					entidades[i].movimientoV = entidades[i].movimientoV * -1;
   		}

   		if ((colision & 0b00000011) && entidades[i].propiedades & mask_disparo) {
   			desaparecerEntidad(i);
   		}

		}
	}
}

void sigPantalla(){
	u8 hab_anterior;
	i8 offset;

	hab_anterior = habitacion;
	offset = 0;

	if (entidades[0].y<16) {
		offset = - LABERINTO_COLUMNAS;
		initXY(0,1,176);
		finFase=1;
	}

	if (entidades[0].y>=180) {
		offset = LABERINTO_COLUMNAS;
		initXY(0,1,24);
		finFase=1;
	}

	if (entidades[0].x<=2) {
		offset = - 1;
		initXY(0,0,71);
		finFase=1;
	}

	if (entidades[0].x>=(78 - 3)) { //Como esta condición es sólo para el prota, ponemos
		// el ancho en constante, para que en tiempo de compilación haga la resta 
		// y en el código ya está x == 75
		offset = 1;
		initXY(0,0,4);
		finFase=1;
	}

	if (finFase) {
		habitacion = habitacion + offset;
		if ((hab_anterior == hab_jefes[0] || hab_anterior == hab_jefes[1]) && habitacion == hab_anterior + LABERINTO_COLUMNAS){
			cpct_setVideoMemoryPage(mem_page); 
			entering();
		}

		if (habitacion == HABITACION_FINAL + LABERINTO_COLUMNAS) {
			game_over = 2;
		}
	}
	
}

void initGame() {
	u8 i, random;

	entidades[0].id = 1; 
	resetMov (0);
 	initXY(0,0,26);
 	initXY(0,1,24);
 	entidades[0].alto = 16;
 	entidades[0].ancho = 4;
 	entidades[0].propiedades = mask_pintar;
 	entidades[0].sprite_f1 = (u8*) &G_Player_R_F1[0];
 	entidades[0].sprite_f2 = (u8*) &G_Player_R_F2[0]; 
 	entidades[0].sprite_f3 = (u8*) &G_Player_R_F3[0]; 
  entidades[0].data2 = 0;

  stop = 0;
 	ciclo = 0;
   
 	random = cpct_rand() % 3;

 	for (i=0; i<(LABERINTO_COLUMNAS*LABERINTO_FILAS)/2; i++) {
 		laberinto[i] = laberinto1[i+(36*random)];
 	}

 	hab_jefes[0]=hab_jefes1[0 + (2*random)];
 	hab_jefes[1]=hab_jefes1[1 + (2*random)];

 	tarjetas[0]=tarjetas1[0 + (3*random)];
 	tarjetas[1]=tarjetas1[1 + (3*random)];
 	tarjetas[2]=tarjetas1[2 + (3*random)];

  for (i = 0; i < (LABERINTO_COLUMNAS*LABERINTO_FILAS)/8; i++) {
  	laberinto_hechos[i] = 0x00;
  }

  habitacion = HABITACION_INICIAL;
  energia = MAX_ENERGIA;
  game_over = 0;
  score = 0;
  bonus_medical = 0;
  area = 0;
}

void entering(){
	u8 y;
	u8* sprite;

	musica=0;
	PLY_AKG_STOP();

	if ((habitacion == HABITACION_INICIAL && area == 0) || (habitacion >= 24 && area == 1) || (habitacion >= 48 && area == 2)) {
		area++;
		clearScr();
		
		cpct_setVideoMemoryPage(mem_page);
		printEnter(habitacion);

		sprite = (u8*) &G_Player_D_F1[0];

		for (y=16; y<200-32; y = y + 4) {
			cpct_waitVSYNC();
		  __asm
		    halt 
		    halt
		  __endasm;
		  cpct_waitVSYNC(); 
			if (y == 32 || y == 96) 
				sprite = (u8*) &G_Player_D_F2[0];
			if (y == 48 || y == 112) 
				sprite = (u8*) &G_Player_D_F1[0];
			if (y == 64 || y == 128) 
				sprite = (u8*) &G_Player_D_F3[0];
			if (y == 80 || y == 144)
				sprite = (u8*) &G_Player_D_F1[0];
			cpct_drawSolidBox (cpct_getScreenPtr (mem_start, 36,  y-8), cpct_px2byteM0 (0, 0), 4, 16);
			cpct_drawSpriteMasked (sprite, cpct_getScreenPtr (mem_start, 36,  y), 4, 16);
		}
	}

	contador_musica = velocidad_musica = 6;
	if (habitacion >= 24 && habitacion < 48) {
	  	__asm
		    ld hl,#_GAME2_START    ;The music.
		    ld a, #0     ;The Subsong to play (>=0).
		    call _PLY_AKG_INIT
		__endasm;
	} else  {
		__asm
		    ld hl,#_GAME1_START    ;The music.
		    ld a, #0     ;The Subsong to play (>=0).
		    call _PLY_AKG_INIT
		__endasm;
	}
	musica = 1;
}

void game(){
	u8 i,salidas;
	u8 visitadas;

	//Inicializar a la Velocidad correspondiente
	

	while (!game_over){
		clearScr();
		initFase();

		while (!finFase) {
			frames++;

			bucle = 0;
			//Cambiar la pantalla donde pintar para preparar siguiente barrido
			if (!swap_memvideo) {
				mem_start = (u8*) 0x8000;
				mem_page = cpct_page80;
			} else {
				mem_start = (u8*) 0xC000;
				mem_page = cpct_pageC0;
			}

//cpct_setBorder(HW_BLACK);
			colisiones(); //Comprobar colisiones antes de ejecutar siguiente movimiento
//cpct_setBorder(HW_RED);
			teclado(); //Movimiento
//cpct_setBorder(HW_GREEN);
	  		iA(); //IA Enemigos
//cpct_setBorder(HW_WHITE);
			moverEntidades();
//cpct_setBorder(HW_BRIGHT_WHITE);
			borrarEntidades();
//cpct_setBorder(HW_PINK);
			pintarEntidades();
//cpct_setBorder(HW_PASTEL_BLUE);

			//*(u8*)&txtFps[0]=bucle;

			while (bucle <= 2) 
				cpct_waitVSYNC(); //Esperar a que la pantalla ya esté lista y pintada

			//printFps(); /* *** */
			cpct_setVideoMemoryPage(mem_page);  //Visualizar la página preparada
			swap_memvideo = ~swap_memvideo; 

			ciclo++;
			if (ciclo == 16)
				ciclo = 0;

			if (habitacion == hab_jefes[0] || habitacion == hab_jefes[1] || habitacion == HABITACION_FINAL) {
				parpadeo();
			}

			if (tiempo != 0 && ciclo == 0) {
				tiempo--;
				pintarTiempo();
			}

			if (tiempo == 0) {
				if (cpct_getBit (&laberinto_hechos[0], habitacion) == 0) {
					playFX(9);
					cpct_setBit (&laberinto_hechos[0], 1, habitacion);

					/*damage = (100 * (energia_fin - energia)) / energia_fin;
					score = score + 4 * (100-damage);*/
					//pintarEscenario();
					for (i=1; i<MAX_ENTIDADES; i++) {
						desaparecerEntidad(i);
					}

					pintarTiempo();
					pintarPuertas();

					//Si es callejón, mostrar botiquín o llave
					/*salidas = 0;
					for (i=0; i<4; i++) {
						if (cpct_getBit (&laberinto[0], (habitacion*4) + i ))
							salidas++;
					}*/

					//CrearLlave si es el caso
					crearItem(1);

				}
				sigPantalla();
			} 

		}
	}
	//Restaurar por si se quedó en oscuro
	cpct_memcpy (&paleta[0],&paleta_original,16);
  cpct_setPalette(paleta,16); 

	if (energia == 0) {
		playFX(11);
		pausa();
	}

	//Pantalla game over
	visitadas = 0;
	for (i=0;i<72;i++)
		if (cpct_getBit (&laberinto_hechos[0], i))
			visitadas++;

	visitadas = 100 - ((100 * (72 - visitadas))/72);

	printGameOver(visitadas, game_over);

	if (habitacion == HABITACION_FINAL + LABERINTO_COLUMNAS) { //Bonus por % visitado
		addScore(visitadas*100);
		printBonusScore();
		addScore(energia*100);
	}

	printFinalScore(score);

	if (score>hiscore)
		hiscore = score;

	pausa();
	while (!cpct_isAnyKeyPressed_f()) {
    	cpct_scanKeyboard_f();
  	}
}