#define MAX_ENTIDADES 13

#define AREA_JUEGO_SUP 16 
#define AREA_JUEGO_INF 200 
#define AREA_JUEGO_IZQ 0
#define AREA_JUEGO_DCHA 80

#define MAX_TILES_SOLID 19
#define MAX_TILES_LETHAL 30
#define TILE_ITEMS 31

#define mask_pintar      0b00000001 // Entidades que deben ser pintadas
#define mask_frames      0b00000010 // Entidades que deben ser animadas
#define mask_rebotables  0b00000100 // Entidades (enemigos) que deben rebotar al colisionar
#define mask_perseguidor 0b00001000 // Entidades (enemigos) que persiguen al protagonista
#define mask_disparo     0b00010000 // Disparo

extern u8 paleta[16];
extern const u8 paleta_original[16];
extern const u8 paleta_oscura[16];
extern u8* mem_start;
extern u8 mem_page;
extern u8 swap_memvideo;
extern u8 musica;
void playFX(u8 instr) __z88dk_fastcall;
void parpadeo();

typedef struct { //23 Bytes
   u8 id; //0=NO USAR; 1=Protagonista; 
   u8 x;
   u8 y;
   i8 movimientoV; //0=nada; -1=arriba;      1=abajo
   i8 movimientoH; //0=nada; -1=izquierda;   1=derecha
   u8 x_anterior_A;
   u8 y_anterior_A;
   u8 x_anterior_B;
   u8 y_anterior_B;
   u8 alto;
   u8 ancho;
   u8 propiedades;
   i8 data1;
   i8 data2;
   u8* sprite_f1; //sprite asociado frame 1
   u8* sprite_f2; //sprite asociado frame 2
   u8* sprite_f3; //sprite asociado frame 3
//   u8* sprite_f4; //sprite asociado frame 4
} TEntidad;


extern TEntidad entidades[MAX_ENTIDADES];
extern u8 ciclo;
extern u8 mapa[20*23];
extern u8 finFase;

#define LABERINTO_FILAS 9
#define LABERINTO_COLUMNAS 8

extern u8 habitacion;
extern u8 laberinto[(LABERINTO_COLUMNAS*LABERINTO_FILAS)/2];
extern u8 hab_jefes[2];
extern u8 tarjetas[3];
extern const u8 laberinto1[(LABERINTO_COLUMNAS*LABERINTO_FILAS)/2];
extern const u8 laberinto2[(LABERINTO_COLUMNAS*LABERINTO_FILAS)/2];
extern const u8 laberinto3[(LABERINTO_COLUMNAS*LABERINTO_FILAS)/2];
extern const u8 hab_jefes1[2];
extern const u8 hab_jefes2[2];
extern const u8 hab_jefes3[2];
extern const u8 tarjetas1[3];
extern const u8 tarjetas2[3];
extern const u8 tarjetas3[3];
extern u8 laberinto_hechos[(LABERINTO_COLUMNAS*LABERINTO_FILAS)/8];

typedef struct {
   u8 id;
   u8 x;
   u8 y;
   i8 data;
} TEnemigo;

#define MAX_ENEMIGOS 300
extern TEnemigo  enemigos[MAX_ENEMIGOS]; 
extern TEnemigo* enemigos_ptr;
#define RESET_DISPARO 30

extern u8 contador_int;
extern u8 bucle;

extern u8 contador_musica;
extern u8 velocidad_musica;

extern u8 tiempo;

#define MAX_ENERGIA 60
extern u8 energia;
extern u8 energia_fin;

extern u8 game_over;

#define TIPO_EJES 2
#define TIPO_ALEATORIO 3
#define TIPO_PERS_ESTATICO 4
#define TIPO_PERS_PATRULLA 5
#define TIPO_PERSEGUIDOR 6
#define TIPO_CANNON 7
#define DISPARO_CANNON_LATERAL 8
#define DISPARO_CANNON_VERTICAL 9
#define TIPO_DISPARO 10
#define DISPARO 11
#define TIPO_PINCHOS 12
#define TIPO_POSTES 20
#define TIPO_CONCURSANTE_1 30
#define TIPO_CONCURSANTE_2 31
#define TIPO_OJOS 40
#define TIPO_NULL 99
#define TIPO_TARJETA 101
#define TIPO_MONEDA 150
#define TIPO_RELOJ 151
#define TIPO_INMUNIDAD 152
#define TIPO_CONGELAR 153
#define TIPO_BOTIQUIN 154

extern u16 score;
extern u16 hiscore;
extern u8 reloj_bonus;
extern u8 moneda_bonus;

#define HABITACION_INICIAL 3
#define HABITACION_FINAL 68
void pausa();
extern u8 frames;
extern u8 stop;
extern u16 tileItems[8];
extern const u8 version;
extern u16 bonus_medical;
extern u8 area;