#include <cpctelera.h>
#include "main.h"
#include "graphics.h"
#include "tileset.h"
#include "consola.h"
#include "maps/scr00.h"
#include "maps/scr01.h"
#include "maps/scr02.h"
#include "maps/scr03.h"
#include "maps/scr04.h"
#include "maps/scr05.h"
#include "maps/scr06.h"
#include "maps/scr07.h"
#include "maps/scr08.h"
#include "maps/scr09.h"
#include "maps/scr10.h"
#include "maps/scr11.h"
#include "maps/scr12.h"
#include "maps/scr13.h"
#include "maps/scr14.h"
#include "maps/scr15.h"
#include "maps/scr16.h"
#include "maps/scr17.h"
#include "maps/scr18.h"
#include "maps/scr19.h"
#include "maps/scr20.h"
#include "maps/scr21.h"
#include "maps/scr22.h"
#include "maps/scr23.h"
#include "maps/scr20b.h"


u16* const fondos[LABERINTO_COLUMNAS*3] = 
	{scr00_end, scr01_end, scr02_end, scr03_end, scr04_end, scr05_end, scr06_end, scr07_end, 
	 scr08_end, scr09_end, scr10_end, scr11_end, scr12_end, scr13_end, scr14_end, scr15_end, 
	 scr16_end, scr17_end, scr18_end, scr19_end, scr20_end, scr21_end, scr22_end, scr23_end};

void redibujarTile(u8* mem_start, u8 x, u8 y, u8 ancho, u8 alto) {
	u8 new_x;
	u8 new_y;
	u8 new_ancho;
	u8 new_alto;

	u16 primer_tile;


	// Nos aseguramos de que x e y sean el inicio de un tile (Los tiles son de 8x8 Pixeles => 4x8 Bytes en Modo 0)
	new_x = x - (x % 4); 
	new_y = y - (y % 8); 

	//Averiguar el nº de tiles a redibujar, dependerá del área del sprite 
	//y si estaba alineado o no
	new_ancho = ancho + x % 4;
	if (new_ancho / 4 == 0) // Si es menor, hay que ponerle el ancho máximo por tile (4)
		new_ancho = 4;
	new_ancho = new_ancho / 4 +  ((new_ancho % 4) != 0);

	new_alto = alto + (y % 8);
	if (new_alto / 8 == 0) // Si es menor, hay que ponerle el alto máximo por tile (8)
		new_alto = 8;
	new_alto = (new_alto / 8) + ((new_alto % 8) != 0);

	
	// primer tile del tilemap a dibujar (Usamos 20 porque son el nº de tiles por fila)
	//Ojo tener en cuenta que en mapa[] no está el marcador, restárselo a y
	primer_tile = ((new_y - AREA_JUEGO_SUP) / 8) * 20 + (new_x / 4);  

	cpct_etm_setDrawTilemap4x8_ag (new_ancho, new_alto, 20, &g_tileset_00[0]);
	__asm
		di
	__endasm;
	cpct_etm_drawTilemap4x8_ag ((u8*) cpct_getScreenPtr (mem_start, new_x, new_y), &mapa[primer_tile]);
	__asm
		ei
	__endasm;
}

void redibujarTile2(u8 x, u8 y, u8 ancho, u8 alto) {
	redibujarTile((u8*) 0x8000, x, y, ancho, alto);
	redibujarTile((u8*) 0xC000, x, y, ancho, alto);
}

void pintarPuertas() {
	u8 i,j, acorazada;

	acorazada = 0;
	if (habitacion == hab_jefes[0] || habitacion == hab_jefes[1] || habitacion == HABITACION_FINAL) {
		//Puerta de Tarjeta en Sur
		mapa[448] = 16;
		mapa[449] = 17;
		mapa[450] = 18;
		mapa[451] = 19;
		redibujarTile2(32, 192, 16, 8);
		acorazada = 1 + (habitacion / 24);
	}


	if (cpct_getBit (&laberinto_hechos[0], habitacion)) {

		//Puerta Norte
		if (cpct_getBit (&laberinto[0], (habitacion*4)+0)) {
			for (i=0;i<4;i++) 
				mapa[8+i] = mapa[28+i];
			
			redibujarTile2(32, 16, 16, 8);
		}

		//Puerta Sur
		if (cpct_getBit (&laberinto[0], (habitacion*4)+1)) {
			//Comprobar si es habitación final de área y si tiene la llave correspondiente
			if (acorazada==0 || (acorazada && tarjetas[acorazada-1] == 255)) {
				for (i=0;i<4;i++) 
					mapa[(22*20)+8+i] = mapa[(21*20)+8+i];
				
				redibujarTile2(32, 192, 16, 8);
			}
		}

		//Puerta Oeste
		if (cpct_getBit (&laberinto[0], (habitacion*4)+2)) {
			for (i=0;i<5;i++)
				mapa[(9+i)*20] = mapa[((9+i)*20) + 1];
			
			redibujarTile2( 0, 88,  4, 40);
		}

		//Puerta Este
		if (cpct_getBit (&laberinto[0], (habitacion*4)+3)) {
			for (i=0;i<5;i++)
				mapa[((9+i)*20) + 19] = mapa[((9+i)*20) + 18];
			
			redibujarTile2(76, 88,  4, 40);
		}

		//Habitación Final, desaparecer enemigo final para cruzar la puerta
		if (habitacion == HABITACION_FINAL) {
			for (j=17; j<= 22; j++)
				for (i=6; i<= 13; i++)
					mapa[(20*j)+i] = 35; //Restablecer suelo de la habitación del jefe final

			redibujarTile2(20, 152,  40, 48);
		}
	}
}

void pintarEnergia(){
	u8 temp;
	u8 color2;

	color2=13;
	if (energia < 20)
		color2=9;
	cpct_drawSolidBox(cpctm_screenPtr ((u8*) 0x8000, 4, 4),cpct_px2byteM0 (0, 0) ,MAX_ENERGIA/2,8);
	cpct_drawSolidBox(cpctm_screenPtr ((u8*) 0xC000, 4, 4),cpct_px2byteM0 (0, 0) ,MAX_ENERGIA/2,8);
	temp = energia / 2;
	if (temp) {
		cpct_drawSolidBox(cpctm_screenPtr ((u8*) 0x8000, 4, 4),cpct_px2byteM0 (13, 13) ,temp,8);
		cpct_drawSolidBox(cpctm_screenPtr ((u8*) 0xC000, 4, 4),cpct_px2byteM0 (color2, color2) ,temp,8);
	}
}


void pintarTiempo(){
	u8* sprite;
	
	sprite = (u8*) &G_Timer_0[0];
	sprite = sprite + (7 - (tiempo/32))*56;

	if (tiempo==0)
		sprite = (u8*) &G_Timer_8[0];

	cpct_drawSprite (sprite, cpctm_screenPtr ((u8*) 0x8000, 35, 1), 4, 14);
	cpct_drawSprite (sprite, cpctm_screenPtr ((u8*) 0xC000, 35, 1), 4, 14);
	
}

void pintarMarcador() {
	u8 i;

	//Sprite
	cpct_drawSpriteMasked (G_Player_R_F1, cpctm_screenPtr ((u8*) 0x8000, 0, 0), 4, 16);
	cpct_drawSpriteMasked (G_Player_R_F1, cpctm_screenPtr ((u8*) 0xC000, 0, 0), 4, 16);

	pintarEnergia();

	pintarTiempo();
	printScoreBoard();
	printScore(score,0);
	printScore(hiscore,8);

	//Mapa
	for (i = 0; i < LABERINTO_COLUMNAS*LABERINTO_FILAS; i++) {
		if (cpct_getBit (&laberinto_hechos[0], i)) {
			cpct_drawSolidBox (cpct_getScreenPtr ((u8*) 0x8000, 62 + (i%8), 3+ (i/8)), cpct_px2byteM0 (2, 2), 1, 1);
			cpct_drawSolidBox (cpct_getScreenPtr ((u8*) 0xC000, 62 + (i%8), 3+ (i/8)), cpct_px2byteM0 (2, 2), 1, 1);
		}
	}
	cpct_drawSolidBox (cpct_getScreenPtr ((u8*) 0x8000, 62 + (habitacion%8), 3+ (habitacion/8)), cpct_px2byteM0 (9, 9), 1, 1);
	cpct_drawSolidBox (cpct_getScreenPtr ((u8*) 0xC000, 62 + (habitacion%8), 3+ (habitacion/8)), cpct_px2byteM0 (6, 6), 1, 1);

	if (tarjetas[0]==255){
		cpct_drawSolidBox (cpct_getScreenPtr ((u8*) 0x8000, 71,  1), cpct_px2byteM0 (9, 0), 1, 4);
		cpct_drawSolidBox (cpct_getScreenPtr ((u8*) 0xC000, 71,  1), cpct_px2byteM0 (9, 0), 1, 4);
	}

	if (tarjetas[1]==255){
		cpct_drawSolidBox (cpct_getScreenPtr ((u8*) 0x8000, 71,  6), cpct_px2byteM0 (13, 0), 1, 4);
		cpct_drawSolidBox (cpct_getScreenPtr ((u8*) 0xC000, 71,  6), cpct_px2byteM0 (13, 0), 1, 4);
	}

	if (tarjetas[2]==255){
		cpct_drawSolidBox (cpct_getScreenPtr ((u8*) 0x8000, 71, 11), cpct_px2byteM0 (7, 0), 1, 4);
		cpct_drawSolidBox (cpct_getScreenPtr ((u8*) 0xC000, 71, 11), cpct_px2byteM0 (7, 0), 1, 4);
	}

	//Habitación actual
	printRoom(habitacion);
}


void pintarEscenario() {
	u8 *mapa_ptr;
	

	mapa_ptr = (u16*) fondos[habitacion % 24];
	if (habitacion == HABITACION_FINAL)
		mapa_ptr = (u16*) scr20b_end;

	cpct_zx7b_decrunch_s((void *) (&mapa[0]+((20*23)-1)),(void *) mapa_ptr);

	//puertas();

	cpct_etm_setDrawTilemap4x8_ag (20, 23, 20, &g_tileset_00[0]);
	__asm
		di
	__endasm;
  	cpct_etm_drawTilemap4x8_ag (cpctm_screenPtr((u8*) 0x8000,0,AREA_JUEGO_SUP) , &mapa[0]);
	cpct_etm_drawTilemap4x8_ag (cpctm_screenPtr((u8*) 0xC000,0,AREA_JUEGO_SUP) , &mapa[0]);
	__asm
		ei
	__endasm;

	pintarPuertas();
}

void borrarEntidades(){
	u8 x,y;
	u8 i;

	for (i = 0; i < MAX_ENTIDADES; i++) {
		if (entidades[i].id != 0) { 
			if (!swap_memvideo){
				x = entidades[i].x_anterior_B;
				y = entidades[i].y_anterior_B;
			}
			else {
				x = entidades[i].x_anterior_A;
				y = entidades[i].y_anterior_A;
			}
			/*if (entidades[i].id >253)
				cpct_drawSolidBox (cpct_getScreenPtr (mem_start, x,  y), 0x00, entidades[i].ancho, entidades[i].alto);
			else*/
			redibujarTile(mem_start, x, y, entidades[i].ancho, entidades[i].alto);
		}
		if (entidades[i].id > 253) {
			entidades[i].id--;
		}
		if (entidades[i].id == 253) {
			entidades[i].id = 0;
		}
	}

	
}
	
void pintarEntidades(){	
	u8 i, anim, color;
	u8* sprite;

	//Protagonista último para que quede pintado sobre los demás
	for (i = MAX_ENTIDADES-1; i != 0xFF; i--) { 
		if (entidades[i].id != 0) { //Para entidades vivas y pintables
			if (entidades[i].propiedades & mask_pintar) {
				sprite = entidades[i].sprite_f1;
				anim = ciclo / 2;
				if (i == 0)
					anim = ciclo % 8;
				
				if (entidades[i].propiedades & mask_frames) {
					if (anim > 1) 
						sprite = entidades[i].sprite_f2;
					if (anim > 3) 
						sprite = entidades[i].sprite_f1;
					if (anim > 5)  
						sprite = entidades[i].sprite_f3;
					
				}
				if (i == 0) {
					//Recalcular sprite del protagonista según dirección
					if (entidades[0].data1 == 1) {
						sprite = sprite + 3*128;
					}
					if (entidades[0].data1 == 2) {
						sprite = sprite + 6*128;
					}
					if (entidades[0].data1 == 3) {
						sprite = sprite + 9*128;
					}
				}

				color = cpct_px2byteM0 (9, 9);
				if (entidades[i].id == 14 && entidades[i].data1 > 40) //Si está saliendo láser, que sea verde
					color = cpct_px2byteM0 (13, 13);				

				if (entidades[i].id == 8 || entidades[i].id == 9 || entidades[i].id == 14)
					cpct_drawSolidBox (cpct_getScreenPtr (mem_start, entidades[i].x,  entidades[i].y), color, entidades[i].ancho, entidades[i].alto);
				else {
					if ((i==0 && entidades[0].data2 && ciclo % 2) || (entidades[i].id >= TIPO_MONEDA && entidades[i].data1<50 && ciclo % 2)) //Los ítems parpadean cuando quede poco para desaparecer
						;
					else
						cpct_drawSpriteMasked (sprite, cpct_getScreenPtr (mem_start, entidades[i].x,  entidades[i].y), entidades[i].ancho, entidades[i].alto);
				}


				//Guardar posición para borrar
				if (!swap_memvideo) {
					entidades[i].x_anterior_B = entidades[i].x;
					entidades[i].y_anterior_B = entidades[i].y;
				} else {
					entidades[i].x_anterior_A = entidades[i].x;
					entidades[i].y_anterior_A = entidades[i].y;
				}
			}
		}
	}
}